<template>
    <div>
        <div class="content">
            <div class="container-fluid">
                <h1>I will show how all other components react to changes</h1>
                Current state of counter is : {{counter}}

                <div>
            <comA></comA>
        </div>
        <div>
            <comB></comB>
        </div>
        <div>
            <comC></comC>
        </div>

        <Button type="info" @click="changeCounter">Change Counter</Button>
            </div>
        </div>

    </div>
</template>

<script>
import comA from './comA'
import comB from './comB'
import comC from './comC'
import {mapGetters,mapActions} from 'vuex'
export default {
    data(){
        return {
            localValue: 'Hello'
        }
    },
    computed:{
        ...mapActions([
            'changeCounterAction'
        ]),
        ...mapGetters({
            'counter':'getCounter'
        })
    },
    methods:{
        changeCounter(){
            this.$store.dispatch('changeCounterAction',1);
            //this.$store.commit('changeTheCounter',1);
        },
        runSomething(){
            console.log('Hello World');
        }

    },
    created(){

    },
    components:{
        comA,
        comB,
        comC
    },
    watch:{
        counter(value){
            console.log('couter is changing ',value);
            this.runSomething();
            console.log(this.localValue);
        }
    }
}
</script>